module Controls {
    export function createBigButton (text : string, index : number, resolve : (t : number) => void) {
        let p = document.createElement("p");
        p.classList.add("choice");
        p.appendChild(document.createTextNode(text));

        markButton(p, index, resolve);

        return p;
    }

    function markButton (p : HTMLElement, index : number, resolve : (t : number) => void) {
        p.addEventListener("click", () => {
            resolve(index);
        });

        Controls.KeyHandler.applyCode(p, Controls.KeyHandler.getFirstKeyCode());
    }

    export async function giveChoices (big? : boolean, ...choices : Array<Say | string>) : Promise<Array<any>> {
        let buttons;
        let chosenPromise = <Promise<number>> new Promise((async (resolve) => {
            Controls.KeyHandler.reset();
            let say = new Say();

            for (let i = 0; i < choices.length; i++) {
                let choice = choices[i];
                if (choice instanceof Say) {
                    let button = (await choice.getHTML("p", ["choice"], true))[0];
                    markButton(button, i, resolve);
                    say.add(button);
                } else {
                    say.add(createBigButton(choice, i, resolve))
                }
            }

            buttons = await say.getHTMLContent();
            Elements.CurrentTurnHandler.print(...(buttons));
        }));

        let chosen = await chosenPromise;
        Elements.CurrentTurnHandler.unprint(...buttons);
        return [choices[chosen], chosen];
    }
}